-- ToME - Tales of Maj'Eyal
-- Copyright (C) 2009, 2010, 2011, 2012 Nicolas Casalini
--
-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>.
--
-- Nicolas Casalini "DarkGod"
-- darkgod@te4.org

getBirthDescriptor("class", "Warrior").descriptor_choices.subclass["windwarrior"] = "allow"

newBirthDescriptor{
	type = "subclass",
	name = "windwarrior",
	desc = {
		"In fighting, speed defines the winner. The windwarriors forsake everything for more speed.",
		"They use: Dexterity, Willpower and cunning",
		"#GOLD#Stat modifiers:",
		"#LIGHT_BLUE# * -2 Strength, +7 Dexterity",
		"#LIGHT_BLUE# * -4 Constitution, +5 Willpower, +3 Cunning",
		"#GOLD# Life per level:#LIGHT_BLUE# 0",
	},
	power_source = {technique=true},
	stats = { str=-2, dex=7, con=-4, wil=5, cun=3},
	talents_types = {

		["technique/combat-training"]={true, 0.3},
		["technique/speed"]={true, 0.3},
		["technique/windattack"]={true, 0.3},	
           ["technique/combat-techniques-passive"]={false, 0.3},
		["technique/combat-techniques-active"]={true, 0.3},
		["technique/dualweapon-training"]={true, 0.3},
		["technique/mobility"]={true, 0.3},
		["cunning/lethality"]={false, 0.3},
["cunning/scoundrel"]={false, 0.2},
["cunning/survival"]={true, 0.3},
["cunning/tactical"]={false, 0.1},
["technique/field-control"]={true, 0.2},

	

 },
	talents = {
		[ActorTalents.T_LOCOMOTION] = 1,
		[ActorTalents.T_PINPRICKING] = 1,
		[ActorTalents.T_WEAPON_COMBAT] = 2,
	
	},


	copy = {
		max_life = 100,
		resolvers.equip{ id=true,
			{type="weapon", subtype="dagger", name="iron dagger", autoreq=true, ego_chance=-1000, ego_chance=-1000},
			{type="weapon", subtype="dagger", name="iron dagger", autoreq=true, ego_chance=-1000, ego_chance=-1000},
			{type="armor", subtype="light", name="rough leather armour", autoreq=true, ego_chance=-1000},
		},
	},
	copy_add = {
		life_rating = 0,
	},
}
